#ifndef REGISTRY_H_42
#define REGISTRY_H_42

#include "types.h"

class Registry {
private:
   HKEY key, rootKey;

public:
   char *keyname;
   bool opened;

   Registry(HKEY root = HKEY_LOCAL_MACHINE);

   void open(const char *product,DWORD sam);
   void create(const char *product);
   void close();
   void remove(const char *subkey);

   void readDWORD(const char *name, DWORD *dest);
   void readString(const char *name, char *dest, DWORD size);
   void writeDWORD(const char *name, DWORD data);
   void writeString(const char *name, const char *data);

   ~Registry();
};

#endif
