/*
 *--------------------------------------------------------------------
 *
 * SurfaceManager
 *
 * Spravuje surfaces. Kazda surface je prirazena spolu se svym
 * jmenem - pokud nejde o jmeno souboru, je prvnim znakem jmena
 * hvezdicka
 *
 * verze   0.0.5 - 16.06.1999
 *
 *--------------------------------------------------------------------
 */

#ifndef SURFACEMANAGER_H
#define SURFACEMANAGER_H

#include "consts.h"
#include "types.h"
#include "r16.h"

#define MAX_SURFACES 100

struct SurfaceEx {
   Surface lpDDSData;
   Name szName;
   Name szFakename;
   R16Header *lpR16h;
   bool bUseDirectory;
};

class SurfaceManager {
   SurfaceEx surfaces[MAX_SURFACES];
   int count;
   

public:
   char *directory;

   SurfaceManager();
   ~SurfaceManager();
    
   void add(Surface surf, char *name, char *fakename, R16Header *r16h, 
      bool useDirectory = true);
   Surface create(DWORD width, DWORD height, char *name, 
      DWORD caps = DDSCAPS_OFFSCREENPLAIN);
   Surface get(char *name);
   R16Header* getHeader(char *name);
   R16Header* getHeader(Surface surf);
   Surface load(char *name, char *fakename, bool useDirectory = true, 
      DWORD dwCaps = DDSCAPS_OFFSCREENPLAIN);
   void remove(char *name, bool release = true);
   void remove(Surface surf, bool release = true);
   void restore();
   void setDirectory(char *dir);
   void setName(Surface surf, char *name);
};

extern SurfaceManager *surfaceManager;

#endif