//************************************************************************
//                            Bublifuk class                              
//************************************************************************
//  Written by : Vojvo, Gunny
//  Language   : VisuC6 + DX6.1
//  Version    : 0.10.1
//  Last update: 14.11.99
//************************************************************************
// changes:
// 0.10.1 - zvuky stereo

#include "utils.h"
#include "game.h"
#include "graphDD.h"
#include "wsound.h"
#include "sprites.h"

#define BUBBLING 128
#define NO_SYM   128

//---------------------------------------------------------------------------
Bublifuk::Bublifuk(int onx, int ony, Property *prop)
{
   gfx = prop->surf;
   state = 0;
   to_fuq = 0;
   fTgs = prop->fTgs;
   x = onx;
   y = ony;
   xsize = prop->xsize;
   ysize = prop->ysize;
   tint = prop->tint;
   bubble = NULL;
}

//--------------------------------------------------------------------------
void Bublifuk::Paint(Surface dest)
{
   if (state & BUBBLING)
      bubble->Paint(dest);
}

//--------------------------------------------------------------------------
void Bublifuk::Clear(Surface dest, Surface src)
{
}

//--------------------------------------------------------------------------
void Bublifuk::jumpNext()
{
   if (state & BUBBLING)
      bubble->jumpNext();
}

//--------------------------------------------------------------------------
void Bublifuk::Action()
{
   if (state & BUBBLING)
   {
      if (bubble->frames.looped)
      {
         bubble->frames.looped = false;
         state ^= BUBBLING;
         to_fuq--;

         if (ARRAY_FULL(symbubs_ctrl))
         {
            delete bubble;
         }
         else
         {
            ARRAY_ADD(symbubs,symbubs_ctrl,bubble);
            bubble->movex = FUQSTRENGTH_STATIC - random(FUQSTRENGTH_DYNAMIC);
            bubble->movey = FUQSTRENGTH_STATIC - random(FUQSTRENGTH_DYNAMIC);
            bubble->frames.setChain(CHAIN_STAND);
            bubble->mask = NULL;
         }
         bubble = NULL;
      }
   }
   else
   {
      // je co foukat a je co pit
      if (to_fuq > 0)
      {
         int ns = random(1000);
         if (ns > 900) ns = 3;
         if (ns > 700) ns = 2;
         if (ns > 400) ns = 1;
         if (ns > 3) ns = 0;
         bubble = new SymbolBubble(x,y,
            properties.member[s_solidbubbles?ID_SOLIDBUBBLEW:ID_SBUBBLE],ns);
         sound_device->Play(0,x+20);
         bubble->mask = gfx;
         bubble->frames.setDirection(DIR_L);
         bubble->direction = DIR_L;
         bubble->frames.setChain(CHAIN_RELEASE);
         state |= BUBBLING;
      }
   }
}
