//***************************************************************************
//                        Kachna class implementation                        
//***************************************************************************
// Written by : Vojvo & Gunny
// Language   : VisuC6 + DX6.1
// Version    : 0.10.1
// Last update: 14.11.99
//***************************************************************************
// changes:
// 0.10.1 - zvuky stereo
// 0.8.1 - pridany zvuky

#include <stdio.h>
#include "dxconsts.h"
#include "consts.h"
#include "utils.h"
#include "exceptions.h"
#include "wsound.h"
#include "map.h"
#include "game.h"
#include "sprites.h"


Kachna::Kachna(int onx, int ony, Property *prop) : Monster(onx,ony,prop)
{
   eggdelay = 428 + random(4569);
}

void Kachna::MapReflex()
{
   int stable;
   
   if (direction == DIR_R)
      stable = stable_r;
   else
      stable = stable_l;
   if (!map_value(newx+stable,newy+ysize,map) && !(action & SPMA_JUMP))
   {
      newx = oldx;
      mul_x = newx << SHIFT_MOVE;
      movex = 0;
      decision ^= 3;
   }
   Monster::MapReflex();
   // snaseni vajec
   if (!(action & SPMA_JUMP)) //at nesnasi v padu
      eggdelay--;
   if (eggdelay==EGG_SHOT) //zastavi se a kvakne, at ma hrac sanci
   {
      movex = 0;
      olddecision = decision;
      decision = 0;
      frames.setChain(CHAIN_FIRE);
      action = SPMA_FIRE;
      sound_device->Play(33,newx+xsize/2); //kvak!
   }
   if (eggdelay<=0) //zkusi neco vypustit!
   {
      eggdelay = EGG_DELAY;
      decision = olddecision;
      action = 0;
      //snaska
      if (UFOcnt < MAX_UFOS)
      {
         UFOs[UFOcnt++] = new Egg(newx,newy+ysize-14,properties.member[ID_EGG],gravitation);
         sound_device->Play(34+random(2),newx+xsize/2);
      }
   }
}