//***************************************************************************
//                              Sheet structure                              
//***************************************************************************
//  Written by : Vojvo & Gunny
//  Language   : VisuC6 + DX6.1
//  Version    : 1.0.1
//  Last update: 14.4.2000
//***************************************************************************
// changes
// 1.0.1  - snaha o prvni plnou verzi
// 0.10.1 - pridan scorefont pro scorelabely, klasicky se pouziva na 
//          zivot za 20000 (caused bug)
//        - score chraneno maximalni hodnotou
// 0.7.1 - upraveny changed z 0/1 na 0-2, kvuli obnove na obou bufferech
//       - z tehoz duvodu rozdeleno na score_changed a energy_changed


#include "game.h"
#include "score.h"
#include "sheet.h"

#define SCORE2LIFE 20000

//==========================================================================
void PSheet::AddPoints(DWORD amount, DWORD x, DWORD y)
{
   amount *= koef;
   score += amount;
   if (score > 99999999L)
      score = 99999999L;
   if (x < 0)
      x = 0;
   if (x != 9999)
   {
      add_score_label(x,y,amount,scorefont);
   }
   
   DWORD new2life = score / SCORE2LIFE;
   if (new2life > old2life)
   {
      /* score boundary for life reward */
      if (player1->sheet.AddLives((BYTE)(new2life-old2life)))
      {
         message.Set("ivot za 20000",font);
      }
      old2life = new2life;
   }
   score_changed = 2;
   return;
}

//==========================================================================
int PSheet::AddLives(BYTE num)
{
   if (lives >= MAX_LIVES)
   {
      return 0;
   }
   int oldlives = lives;
   lives+=num;
   lives_chg = 2;
   if (oldlives == 0)
   {
      if (player1->state & NOTTAKEN)
      {
         player1->state &= ~DEAD;
         ARRAY_ADD(monsters,monsters_ctrl,player1);
      }
      else if (player2->state & NOTTAKEN)
      {
         player2->state &= ~DEAD;
         ARRAY_ADD(monsters,monsters_ctrl,player2);
      }
   }
   return lives;
}
