#ifndef UTILS_H_BUBWINY
#define UTILS_H_BUBWINY

//#define PROFILER_DEBUG

#ifdef PROFILER_DEBUG
#include "profiler.h"
extern PerformanceProfiler *profiler;
#endif

#ifdef CLASSIC_DEBUG
#define DEBUG_MESSAGE(text) OutputDebugString(text);
#else
#define DEBUG_MESSAGE(text)
#endif

#define SAFE_RELEASE(p)    if ((p) != NULL) { (p)->Release(); p = NULL; }
#define SAFE_DELETE(p)     if ((p) != NULL) { delete (p); p = NULL; }

#define random(limit)      ((long)((limit+1)*(float)rand()/(float)RAND_MAX))

extern char pom_string[256];

void numtos(long numb, int width, char *target);

// casovac s pohyblivym ukazatelem
struct Timer {
   int            timemax, timeunit, timecurrent;
   unsigned long  xmin, xmax, xcurrent;
   bool           cutmax;
   bool           ltor;

   Timer();
   Timer (int timemax,unsigned long xmin,unsigned long xmax, 
      bool cutmax = true,bool ltor = true);
   
   int decrease(int amount);
   int increase(int amount);
   void set(int value);
   void options(int timemax,unsigned long xmin,unsigned long xmax,
      bool cutmax,bool ltor);
};

#endif