#ifndef CBUFFER_H_COMMON
#define CBUFFER_H_COMMON

#define DECLARE_CBUFFER_EXTERN(type,name,control_in,control_out,control_size,size) \
   extern type name[size];    \
   extern int control_in;     \
   extern int control_out;    \
   extern int control_size;

#define DECLARE_CBUFFER(type,name,control_in,control_out,control_size,size) \
   type name[size];            \
   int control_in = 0;         \
   int control_out = 0;         \
   int control_size = size;

#define CBUFFER_INSERT(name,control_in,control_out,control_size,data) \
   name[control_in] = data;   \
   if (control_in != ((control_out == 0) ? control_size:control_out-1)) \
   {                          \
      control_in++;           \
      if (control_in == control_size) \
         control_in = 0;      \
   }

#define CBUFFER_RETRIEVE(name,control_in,control_out,control_size,result,null_data) \
   if (control_in != control_out)   \
   {                                \
      result = name[control_out];   \
      control_out++;                \
      if (control_out == control_size) \
         control_out = 0;           \
   }                                \
   else                             \
   {                                \
      result = null_data;           \
   }

      
#define CBUFFER_RESET(name,control_in,control_out) \
   control_in = 0; \
   control_out = 0;

#endif
      



