/*
 *--------------------------------------------------------------------
 *
 * Fader
 *
 * Usek hry - ztmivac/roztmivac obrazovky
 *
 * verze   0.7.1 - 22.09.1999
 * autori  Vojvo
 *
 *--------------------------------------------------------------------
 * zmeny
 *
 * 0.7.1 - prvni verze
 *--------------------------------------------------------------------
 */

#include "graphdd.h"
#include "application.h"
#include "fader.h"

#define FADE_SPEED       15
#define FADE_STEP_TIME   10

//-------------------------------------------------------------------------
// inicializuje veci potrebne pro spousteni
//-------------------------------------------------------------------------
void Fader::load()
{
}

//-------------------------------------------------------------------------
// zahajuje cinnost
//-------------------------------------------------------------------------
void Fader::start()
{
   step = 0;
   done = false;
   oldtime = GetTickCount();
}

//-------------------------------------------------------------------------
// pravidelna cinnost pri kazdem pruchodu hlavni smyckou programu
//-------------------------------------------------------------------------
void Fader::update()
{
   RECT r1,r2;
   DWORD deltat;
   DWORD steps;
   int from;
   int to;
   
   // klavesnice
   kbd.getState();

   time = GetTickCount();
   deltat = time - this->oldtime;
   steps = deltat/(DWORD)FADE_STEP_TIME;
   
   if (steps > 0)
   {
      this->oldtime = time;
      
      if (dir == FADE_OUT)
      {
         from = step*FADE_SPEED;
         step += steps;
         to = step*FADE_SPEED;
         if (from < 0 || from >= 640)
         {
            from = 0;
            done = true;
         }
         if (to < 0 || to >= 640)
         {
            to = 640;
            done = true;
         }
         r1.left = from;
         r1.right = to;
         r2.left = 640-to;
         r2.right = 640-from;
         for(int j=0; j<480; j++)
         {
            if (j & 1)
            {
               r1.top = j;
               r1.bottom = j+1;
               clear(frontbuffer,0,&r1);
            }
            else
            {
               r2.top = j;
               r2.bottom = j+1;
               clear(frontbuffer,0,&r2);
            }
         }
      }
      else
      {
         done = true;
      }
      if (done)
      {
         app->stateChange();
      }
   }
   
}

//-------------------------------------------------------------------------
// obnoveni po surface lost
//-------------------------------------------------------------------------
void Fader::restore()
{
}

//-------------------------------------------------------------------------
// cinnost pri zastaveni zobrazovani objektu
//-------------------------------------------------------------------------
void Fader::stop()
{
}

//-------------------------------------------------------------------------
// cinnost pri definitivnim ukonceni pouzivani
//-------------------------------------------------------------------------
void Fader::unload()
{
}

//-------------------------------------------------------------------------
// nastaveni smeru ztmivacky
//-------------------------------------------------------------------------
void Fader::setFadeDir(int fadedir)
{
   dir = fadedir;
}