//*************************************************************************
//                                Hiscore                                   
//*************************************************************************
// Written by : Gunny & Vojvo
// Language   : VisuC6 + DX6.1
// Version    : 1.0.1
// Last update: 14.4.2000
//*************************************************************************
// CHANGES:
// 1.0.1 - snaha o prvni plnou verzi
// 0.9.4 - prvni verze

#include <stdio.h>
#include <string.h>
#include "utils.h"
#include "font.h"
#include "topper.h"

#define TOPFILE         "Toppers.hsc"

Toppers *toppers = NULL;

//=========================================================================
//-------------------------------------------------------------------------
//                                  Topper
//-------------------------------------------------------------------------
//=========================================================================

//-------------------------------------------------------------------------
// default konstruktor
//-------------------------------------------------------------------------
Topper::Topper()
{
   score= 42; // =)
   name = NULL;
   name = new char[TOP_NAMELEN];
   fnt = &qfont_y;
   newone = false;
}

//-------------------------------------------------------------------------
// konstruktor s parametry
//-------------------------------------------------------------------------
Topper::Topper(char * n, long s, Font *f)
{
   name = NULL;
   name = new char[TOP_NAMELEN];
   if (name)
      strcpy(name,n);
   score=s;
   fnt = f;
   newone = false;
}

//-------------------------------------------------------------------------
// destruktor
//-------------------------------------------------------------------------
Topper::~Topper()
{
   if (name != NULL)
   {
      delete [] name;
      name = NULL;
   }
}

//=========================================================================
//-------------------------------------------------------------------------
//                                 Toppers
//-------------------------------------------------------------------------
//=========================================================================
//-------------------------------------------------------------------------
// konstruktor
//-------------------------------------------------------------------------
Toppers::Toppers()
//vsechno vynuluje a vyNULLuje =)
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      data[i] = NULL;
      data[i] = new Topper();
   }
}

//-------------------------------------------------------------------------
// destruktor
//-------------------------------------------------------------------------
Toppers::~Toppers()
//co je neNULLove, dealokuje
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      SAFE_DELETE(data[i]);
   }
}

//-------------------------------------------------------------------------
// vola se, kdyz neexistuje soubor 
//-------------------------------------------------------------------------
void Toppers::New()
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      strcpy(data[i]->name,"Eriador");
      data[i]->score=(TOP_MAXTOP-i)*500;
      data[i]->fnt= &qfont_y;
   }
   strcat(data[0]->name," ");
   data[0]->score=100000L;
}

//-------------------------------------------------------------------------
//dvojzvratny xor kod =) 
//-------------------------------------------------------------------------
void cood(char * to, char * from)
{
   while (*from)
   {
      *to=(*from ^ 128);
      from++;
      to++;
   }
   *to=0;
}

//-------------------------------------------------------------------------
// clearuje priznak novych polozek toppers
//-------------------------------------------------------------------------
void Toppers::clearNew()
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      if (data[i]->newone)
      {
         data[i]->newone = false;
         data[i]->fnt = &qfont_y;
      }
   }
}

//-------------------------------------------------------------------------
// snazi se naloadit score ze souboru
//-------------------------------------------------------------------------
int Toppers::Load()
{
   FILE *hisc;
   char cod[TOP_NAMELEN];
   if ((hisc = fopen(TOPFILE, "rb")) == NULL)
      return 43;
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      fread(cod, TOP_NAMELEN, 1, hisc); //jmeno
      cood(data[i]->name,cod);
      if (!fread(&data[i]->score, 4, 1, hisc)) //score
      {//pokud neco neklaplo
         data[i]->score=TOP_MAXTOP-i;
         data[i]->fnt=&qfont_w;
      }
   }
   fclose(hisc);
   return 0;
}

//-------------------------------------------------------------------------
// ulozi do souboru
//-------------------------------------------------------------------------
int Toppers::Save()
{
   FILE *hisc;
   char cod[TOP_NAMELEN];
   if ((hisc = fopen(TOPFILE,"wb")) == NULL)
   {
      return 42;
   }
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      cood(cod,data[i]->name);
      fwrite(cod, TOP_NAMELEN, 1, hisc); //jmeno
      fwrite(&data[i]->score, 4, 1, hisc); //score
   }
   fclose(hisc);
   return 0;
}

//-------------------------------------------------------------------------
// snazi se zaradit zadany vykon do tabulky
//-------------------------------------------------------------------------
int Toppers::Ins(char *name, long score, Font *f)
{
   Topper * tp;
   char i=TOP_MAXTOP-1;
   int res=0;
   if (data[i]->score<=score)
   {
      data[i]->score=score;
      data[i]->fnt=f;
      data[i]->newone = true;
      strcpy(data[i]->name,name);
      while (i>0 && data[i]->score > data[i-1]->score)
      {
         res=1;
         tp=data[i];
         data[i]=data[i-1];
         data[i-1]=tp;
         i--;
      }
   }
   return res;
}

