#ifndef _WSOUND_H
#define _WSOUND_H

#include "dxconsts.h"
#include <dsound.h>

#define NAMELEN     9
#define MAXSAMPLES 40
#define MAXPOLY     3 

struct NFXHeader
{
  char  id[6];
  short frequency;
  short count;
};

struct SampleHeader
{
  long startpos;
  long length;
  char name[9]; //8 znaku + '0'
  BYTE copies;
};

#define WERR_NODEVICE      -1
#define WERR_NOFILE         1
#define WERR_BADFILE        2
#define WERR_NOSUCHSAMPLE   4
#define WERR_CANTALLOCATE   8
#define WERR_CANTDUPLICATE 16

class PolySample {
public:
  // - promenne -
  int copies;
  int active;
  LPDIRECTSOUNDBUFFER   buffer[MAXPOLY];

  // - metody -
  PolySample();
  // constructor
  LPDIRECTSOUNDBUFFER Active();
  // vraci aktivni kanal samplu
  DeleteSample();
};

class WSound {
public:

  // - promenne -
  LPDIRECTSOUND dsound;
  LPDIRECTSOUNDBUFFER   primarybuffer;
  PolySample            sample[MAXSAMPLES];
  DSBUFFERDESC          bufferdescriptor;
  HWND winhandle;
  HRESULT result;
  NFXHeader filehead;
  SampleHeader          samplehead[MAXSAMPLES];
  DWORD                 max_x;
  bool reverse_stereo;
  //
  char filename[64];
  char errorname[32];
  int werror;
  int initLevel;
  
  // - metody -
  WSound(HWND w, GUID *pguid, char * filenam);
  // constructor
  ~WSound();
    // splachne, zhasne, zamkne =)
  int  OpenFile();
    // otevre soubor se samply a nacte jeho hlavicku
  int  LoadSamples();
    // nacte vsechny samply z nastaveneho souboru
  int  LoadSample(int num);
    // nacte num.sampl z nastaveneho souboru
  int  FindSample(char * samplename);
    // najde id samplu urciteho jmena (nebo vraci -1)
  int  SetPrimaryBuffer(int channels);
    // nastavi primrnimu bufferu informace ziskane z hlavicky souboru
  int  AllocateSamples();
    // jednoduse alokuje samplebuffery
  int  DuplicateSamples();
    // vytvari kopie samplu pro polyfonii
  void Play(int num, DWORD x = 320); // panning je od -10000 do 10000
    // prehraje sampl ulozeny na pozici num
  void Play(char * samplename, DWORD x = 320); 
    // prehraje sampl s danym jmenem
  void Run();
    // spusti natvrdo mixer (totiz primarybuffer)
  void SetVolume(LONG vol);
    // nastavi master volume (od DSBVOLUME_MIN=0 do DSBVOLUME_MAX)
  void GetVolume(LPLONG vol);
    // nacte master volume (od DSBVOLUME_MIN=0 do DSBVOLUME_MAX)
};

extern WSound *sound_device;

#endif